package com.belkast.soap;

import com.beust.jcommander.ParameterException;
import com.beust.jcommander.*;

import java.io.File;
import java.net.HttpURLConnection;
import java.text.SimpleDateFormat;
import java.util.*;

public class webService {
    static Date dateStart = new Date();
    static SimpleDateFormat varFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

    static Boolean varDebug = false;
    static String varKey;
    static String varSalt = "1zcHJvdG9ubWFpbC9icmlkZ2UtdjMvdXNlcnMvYnJpZGdlLXZhdWx0LWtleQl0gx";

    public static void main(String... argv) throws Exception
    {
        System.out.println();
        // @Parameter(names = "--props",
        // description = "Location of the Properties file")

        // @Parameter(names = "--key",
        // description = "Encryption Key (length of 16)")

        // @Parameter(names = "--encrypt",
        // description = "Encrypt this value using the Key")

        // @Parameter(names = "--debug",
        // description = "Write details to the screen")

        jCommanderArgs args = new jCommanderArgs();
        JCommander jct = new JCommander(args);
        try {
            jct.parse(argv);
        } catch (ParameterException ex) {
            jct.usage();
            System.exit(0);
        }

        varDebug = args.debug;
        varKey = args.key;
        String varToEncrypt = args.encrypt;

        if (varToEncrypt != null && !varToEncrypt.isEmpty())
        {
            if (varKey == null)
            {
                String varKey = credentialsProcessor.getCredential("Please enter the encryption key (must be 16 characters) : ", 16, true);
            }

            String varToStore = encyptProcessor.encrypt(varToEncrypt, varKey, varSalt);
            String varChecked = encyptProcessor.decrypt(varToStore, varKey, varSalt);

            System.out.println("Clear Text Password : " + varToEncrypt);
            System.out.println("Encryption Key      : " + varKey);
            System.out.println("Encrypted / Encoded : " + varToStore);
            System.out.println("Decoded / Decrypted : " + varChecked);
            System.out.println();
            System.exit(0);
        }

        String varProps = args.props;
        if (varProps == null && varToEncrypt == null)
        {
            debugProcessor.writer(true, "Check the command line parameters. There is nothing to do!");
            System.out.println();
            jct.usage();
            System.exit(0);
        }

        if (!fileProcessor.getFile(varProps) || !fileProcessor.validFile(varProps))
        {
            debugProcessor.writer(true, "Please check that the properties file " + varProps + " is correctly formatted!");
            System.out.println();
            System.exit(0);
        }

        if (varProps != null)
        {
            Map thisFinal = doSoap(new File(varProps));

            System.out.println();
            Map map = (Map) thisFinal.get("results");
            Iterator<Map.Entry<Integer, Map>> iterator = map.entrySet().iterator();

            while (iterator.hasNext())
            {
                Map.Entry<Integer, Map> pair = iterator.next();
                debugProcessor.writer(varDebug, "!! processed " + pair.getKey() + " [" + pair.getValue().get("soap_response") + "] " + pair.getValue());
            }

            System.out.println();
            debugProcessor.writer(true, "!! Connect User   : "  + thisFinal.get("user"));
            debugProcessor.writer(true, "!! Total records  : "  + thisFinal.get("total"));
            debugProcessor.writer(true, "!! Total passed   : "  + thisFinal.get("passed"));
            debugProcessor.writer(true, "!! Total failed   : "  + thisFinal.get("failed"));

            Boolean thisResult = thisFinal.get("total") == thisFinal.get("passed");
            debugProcessor.writer(true, "!! WAS SUCCESSFUL : " + thisResult.toString().toUpperCase());
            if (!thisResult)
            {
                debugProcessor.writer(true, "!! PLEASE CHECK THE DEBUG LOG");
            }
        }

        System.out.println();
        System.exit(0);

    }

    private static Map doSoap(File thisProps) throws Exception {
        String varPassword = "";
        int varFailed = 0;
        Map varResult = new HashMap();

        debugProcessor.writer(false, "Debug setting : " + varDebug);

        String varURL = propertyProcessor.getProperty(thisProps, "SHIM_URL", null);
        String varKeystore_LOC = propertyProcessor.getProperty(thisProps, "JAVA_KS_LOCATION", null);
        String varInputFile = propertyProcessor.getProperty(thisProps, "XML_FILE", null);
        String varRoleFile = propertyProcessor.getProperty(thisProps, "CSV_FILE",null);
        String varKeystore_PW = propertyProcessor.getProperty(thisProps, "JAVA_KS_PASSWORD", null);

        String varPropAuthRequired = propertyProcessor.getProperty(thisProps, "AUTH_REQUIRED", "true");

        String varPropUseSSL = propertyProcessor.getProperty(thisProps, "SSL", "true");

        String varPropEmptyColumns = propertyProcessor.getProperty(thisProps, "CSV_ALLOW_EMPTY_COLUMN_VALUES", "false");

        try {
            File checkInput = new File(varInputFile);
            if (!checkInput.exists()) {
                debugProcessor.writer(true, thisProps + " => The file specified in XML_FILE does not exist [ " + varInputFile + " ]");
                System.out.println();
                System.exit(0);
            }

            if (varURL.isEmpty())
            {
                throw new RuntimeException("SHIM_URL cannot be empty");
            }

            File checkRole = new File(varRoleFile);
            if (!checkRole.exists()) {
                debugProcessor.writer(true, thisProps + " => The file specified in CSV_FILE does not exist [ " + varRoleFile + " ]");
                System.out.println();
                System.exit(0);
            }
        }
        catch (Exception e)
        {
            debugProcessor.writer(true, thisProps + " => The properties file is missing a required value!");
            debugProcessor.writer(true, thisProps + " => Required values : SHIM_URL, XML_FILE, CSV_FILE");
            System.out.println();
            System.exit(0);
        }

        Boolean varUseSSL = Boolean.valueOf(varPropUseSSL);
        Boolean varAuthRequired = Boolean.valueOf(varPropAuthRequired);

        Boolean varEmptyColumns = Boolean.valueOf(varPropEmptyColumns);

        String varUsername = propertyProcessor.getProperty(thisProps, "USERNAME", null);
        if (varAuthRequired && varUsername == null)
        {
            varUsername = credentialsProcessor.getCredential("Please enter your username : ", 1, false);
        }

        String varPasswordTemp = propertyProcessor.getProperty(thisProps, "PASSWORD", null);

        if (varAuthRequired)
        {
            if (varPasswordTemp == null)
            {
                // This is just a temporary key so that the rest of the code does not error out!
                varKey = "ZyXwQbRH9VGrAEzN";
                String varUserPW = credentialsProcessor.getCredential("[" + varUsername + "] Please enter your password : ", 1, true);
                varPasswordTemp = encyptProcessor.encrypt(varUserPW, varKey, varSalt);
            }

            if (varKey == null)
            {
                String userKey = credentialsProcessor.getCredential("Please enter the encryption key (must be 16 characters) : ", 16, true);
            }
        }
        else
        {
            varPasswordTemp = null;
        }

        try
            {
                varPassword = encyptProcessor.decrypt(varPasswordTemp, varKey, varSalt);
            }
        catch(Exception e)
            {
                debugProcessor.writer(true, "The password could not be decrypted. Please check the encryption key!");
                System.out.println();
                System.exit(0);
            }

        debugProcessor.writer(varDebug, thisProps + " => SOAP URL : " + (varURL == null ? "" : varURL));
        debugProcessor.writer(varDebug, thisProps + " => Authentication required : " + varAuthRequired);
        debugProcessor.writer(varDebug, thisProps + " => Use SSL : " + varUseSSL);
        debugProcessor.writer(varDebug, thisProps + " => JAVA keystore location : " + (varKeystore_LOC == null ? "" : varKeystore_LOC));
        debugProcessor.writer(varDebug, thisProps + " => JAVA keystore password : " + (varKeystore_PW == null ? "" : varKeystore_PW));
        debugProcessor.writer(varDebug, thisProps + " => XML file : " + (varInputFile == null ? "" : varInputFile));
        debugProcessor.writer(varDebug, thisProps + " => CSV file : " + (varRoleFile == null ? "" : varRoleFile));
        debugProcessor.writer(varDebug, thisProps + " => CSV allow empty : " + varEmptyColumns);

        if (!varAuthRequired)
        {
            varUsername = null;
            varPassword = null;
        }
        else
        {
            debugProcessor.writer(varDebug, thisProps + " => Username : " + varUsername);
        }

        ArrayList thisCSV = userVerify.readCSV(varRoleFile, false, !varEmptyColumns);

        boolean validfile = (!thisCSV.isEmpty());
        debugProcessor.writer(varDebug, "");
        debugProcessor.writer(true, "CSV file is valid      : " + validfile);
        debugProcessor.writer(true, "CSV records to process : " + thisCSV.size());

        if (!validfile)
        {
            debugProcessor.writer(true, varRoleFile + " => verification failed : please verify the file with com.belkast.soap.userVerify!");
        }

        int varCount = 0;
        Map resultMap = new HashMap();
        Iterator<Map> mapper1 = thisCSV.iterator();
        while (mapper1.hasNext()) {
            varCount++;
            debugProcessor.writer(true, "");
            debugProcessor.writer(varDebug, "[" + varCount + " of " + thisCSV.size() + "] : processing started");

            Map hashMap = mapper1.next();
            Iterator<Map.Entry<Integer, Integer>> it = hashMap.entrySet().iterator();
            while (it.hasNext())
            {
                Map.Entry<Integer, Integer> pair = it.next();
                debugProcessor.writer(varDebug, "record " + varCount + " : " + pair.getKey() + " => " + pair.getValue());
            }

            for(Object key: hashMap.keySet())
            {
                Boolean varHasText = fileProcessor.fileHasText(varInputFile, key.toString());
                debugProcessor.writer(varDebug, "[before] " + varInputFile + " : " + key + " token exists => " + varHasText);
            }

            String varXML = fileProcessor.replaceInFile(varInputFile, hashMap);
            for(Object key: hashMap.keySet())
            {
                Boolean varHasText = fileProcessor.stringHasText(varXML, key.toString());
//              debugProcessor.writer(varDebug, "[after] " + varInputFile + " : " + key + " token exists => " + varHasText);
            }

            HashMap<Boolean, String> errorMap = new HashMap();
            errorMap.put(false, "FAILED");
            errorMap.put(true, "SUCCESS");

            if (varXML != null && !varXML.isEmpty())
            {
                String varCredentials = soapProcessor.getCredentials(varUsername, varPassword);

                debugProcessor.writer(true, "[" + varCount + " of " + thisCSV.size() + "] : opening connection to " + varURL);
                HttpURLConnection varConn = soapProcessor.getConnection(varCredentials, varURL, varUseSSL, varKeystore_LOC, varKeystore_PW);

                debugProcessor.writer(true, "[" + varCount + " of " + thisCSV.size() + "] : sending XML document");
                debugProcessor.writer(varDebug, "[" + varCount + " of " + thisCSV.size() + "] : SOAP call logging in   : " + varAuthRequired);
                debugProcessor.writer(varDebug, "[" + varCount + " of " + thisCSV.size() + "] : SOAP call sending data : " + varXML);

                Map response = soapProcessor.send(varConn, varXML.getBytes());
                debugProcessor.writer(true, "[" + varCount + " of " + thisCSV.size() + "] : SOAP call response code  : " + response.get("code"));

                boolean varSuccess = Boolean.valueOf(response.get("success").toString());
                debugProcessor.writer(!varSuccess, "[" + varCount + " of " + thisCSV.size() + "] : SOAP call response data  : " + response.get("response"));
                debugProcessor.writer(true, "[" + varCount + " of " + thisCSV.size() + "] : SOAP call was successful : " + Boolean.valueOf(response.get("success").toString()));

                if (!varSuccess)
                {
                    debugProcessor.writer(varDebug, "[" + varCount + " of " + thisCSV.size() + "] : " + hashMap.toString());
                    varFailed++;
                }

                hashMap.put("csv_file",  varInputFile);
                hashMap.put("csv_records",  thisCSV.size());
                hashMap.put("date",  new Date());
                hashMap.put("soap_auth", varAuthRequired);
                hashMap.put("soap_response", response.get("code"));
                hashMap.put("soap_sent_size",  varXML.length());
                hashMap.put("soap_success", response.get("success"));
                hashMap.put("soap_user",  (varUsername == null) ? "N/A" : varUsername);
                hashMap.put("this_record", varCount);
                resultMap.put(varCount,hashMap);

                if (varConn != null)
                {
                    soapProcessor.closeConnection(varConn);
                    debugProcessor.writer(true, "[" + varCount + " of " + thisCSV.size() + "] : connection closed");
                }
            }
        }

        varResult.put("user",  (varUsername == null) ? "N/A" : varUsername);
        varResult.put("total",  thisCSV.size());
        varResult.put("passed", thisCSV.size() - varFailed);
        varResult.put("failed", varFailed);
        varResult.put("results", resultMap);
        return varResult;

    }
}